'*****************************************************************************
'*                        V1.0                     *
'* Chip:  ATMEGA 128                                                         *
'* Freq:  12 Mhz                                                             *
'* Autor:  ..      28  2012 .                          *
'*****************************************************************************

$regfile = "m128def.dat"                                    '   
$crystal = 12000000
$hwstack = 64                                               ' default use 32 for the hardware stack
$swstack = 20                                               ' default use 10 for the SW stack
$framesize = 48                                             ' default use 24 for the frame space
config submode = new
'------------------------------  ----------------------------------
'   
Sub Send()
 Spiout A(1) , 234
 Spiout A(235) , 234
End Sub

' 
Sub ClearArray()
 For i = 1 to 471
  A(i) = 0
 Next i
End Sub

'  
Sub RND_Col()
Gen:
         R = RND(256)
         G = RND(256)
         B = RND(256)
         t1 = R - G
         t2 = R - B
         t3 = G - B
         t1 = Abs(t1)
         t2 = Abs(t2)
         t3 = Abs(t3)
         If t1 < 150 and t2 < 150 and t3 < 150 Then GoTo Gen
End Sub

'     
Sub RinG()
 G = 0
 For R = 255 to 0 step -1
  For i = 1 to 468 step 3
   A(i) = R
   A(i + 1) = G
   A(i + 2) = 0
  Next i
   Send
   waitms 10
  G = G + 1
 Next R
End Sub

'     
Sub GinB()
 B = 0
 For G = 255 to 1 step -1
  For i = 1 to 468 step 3
   A(i) = 0
   A(i + 1) = G
   A(i + 2) = B
  Next i
   Send
   waitms 10
  B = B + 1
 Next G
End Sub

'     
Sub BinR()
 R = 0
 For B = 255 to 1 step -1
  For i = 1 to 468 step 3
   A(i) = R
   A(i + 1) = 0
   A(i + 2) = B
  Next i
   Send
   waitms 10
  R = R + 1
 Next B
End Sub

'     
Sub OffLed_LR()
 For i = 1 to 468 step 3
  A(i) = 0
  A(i + 1) = 0
  A(i + 2) = 0
  Send
  waitms 10
Next i
End Sub

'     
Sub OffLed_RL()
 For i = 468 to 0 step -3
  A(i -2) = 0
  A(i - 1) = 0
  A(i) = 0
  Send
  waitms 10
 Next i
End Sub

'       
Sub OnR_LR()
 For i = 1 to 468 step 3
  A(i) = 255
  A(i + 1) = 0
  A(i + 2) = 0
  Send
  waitms 10
 Next i
End Sub

'       
Sub OnR_RL()
 For i = 468 to 0 step -3
  A(i -2) = 255
  A(i - 1) = 0
  A(i) = 0
  Send
  waitms 10
 Next i
End Sub

'      
Sub OnG_LR()
 For i = 1 to 468 step 3
  A(i) = 0
  A(i + 1) = 255
  A(i + 2) = 0
  Send
  waitms 10
 Next i
End Sub

'      
Sub OnG_RL()
 For i = 468 to 0 step -3
  A(i -2) = 0
  A(i - 1) = 255
  A(i) = 0
  Send
  waitms 10
 Next i
End Sub

'      
Sub OnB_LR()
 For i = 1 to 468 step 3
  A(i) = 0
  A(i + 1) = 0
  A(i + 2) = 255
  Send
  waitms 10
 Next i
End Sub

'      
Sub OnB_RL()
 For i = 468 to 0 step -3
  A(i -2) = 0
  A(i - 1) = 0
  A(i) = 255
  Send
  waitms 10
 Next i
End Sub

'        
Sub OnGradient_LR()
R = 0
G = 0
B = 0
S1 = RND(256)
S2 = RND(256)
S3 = RND(256)
 For i = 1 to 468 step 3
  A(i) = R
  A(i + 1) = G
  A(i + 2) = B
  Send
  waitms 10
  R = R + S1
  G = G + S2
  B = B + S3
 Next i
End Sub

'        
Sub OnGradient_RL()
R = 0
G = 0
B = 0
S1 = RND(256)
S2 = RND(256)
S3 = RND(256)
 For i = 468 to 0 step -3
  A(i -2) = R
  A(i - 1) = G
  A(i) = B
  Send
  waitms 10
  R = R + S1
  G = G + S2
  B = B + S3
 Next i
End Sub

'   
Sub B_Middle()
 j = 232 : k = 235
  For i = 1 to 78
   A(j) = 0
   A(j + 1) = 0
   A(j + 2) = 255

   A(k) = 0
   A(k + 1) = 0
   A(k + 2) = 255
    j = j - 3
    k = k + 3
    Send
    waitms 50
  Next i
End Sub

'   
Sub G_Middle()
 j = 232 : k = 235
  For i = 1 to 78
   A(j) = 0
   A(j + 1) = 255
   A(j + 2) = 0

   A(k) = 0
   A(k + 1) = 255
   A(k + 2) = 0

    j = j - 3
    k = k + 3
    Send
    waitms 50
  Next i
End Sub

'   
Sub R_Middle()
 j = 232 : k = 235
  For i = 1 to 78
   A(j) = 255
   A(j + 1) = 0
   A(j + 2) = 0

   A(k) = 255
   A(k + 1) = 0
   A(k + 2) = 0
    j = j - 3
    k = k + 3
    Send
    waitms 50
  Next i
End Sub

'  
Sub B_Kap_R()
 x = 1
  For i = 1 to M
   p = A(N)
   Select case x
    Case 1 : A(1) = 0
             A(2) = 0
             A(3) = 255
    Case 2 : A(1) = 0
             A(2) = 0
             A(3) = 90
    Case 3 : A(1) = 0
              A(2) = 0
              A(3) = 50
    Case 4 : A(1) = 0
             A(2) = 0
             A(3) = 10
    Case 5 : A(1) = 0
             A(2) = 0
             A(3) = 1
    Case 6 : A(1) = 0
             A(2) = 0
             A(3) = 0
    Case 7 : A(1) = 0
             A(2) = 0
             A(3) = 0
   End Select
   x = x + 1
   If x > 7 Then x = 1
    For k = 1 to 3
     For j = N to 2 Step -1
      A(j) = A(j - 1)
     Next j
    Next k
    Send
    waitms 60
   A(1) = p
  Next i
End Sub

'  
Sub G_Kap_R()
 x = 1
  For i = 1 to M
   p = A(N)
   Select case x
    Case 1 : A(1) = 0
             A(2) = 255
             A(3) = 0
    Case 2 : A(1) = 0
             A(2) = 90
             A(3) = 0
    Case 3 : A(1) = 0
              A(2) = 50
              A(3) = 0
    Case 4 : A(1) = 0
             A(2) = 10
             A(3) = 0
    Case 5 : A(1) = 0
             A(2) = 1
             A(3) = 0
    Case 6 : A(1) = 0
             A(2) = 0
             A(3) = 0
    Case 7 : A(1) = 0
             A(2) = 0
             A(3) = 0
   End Select
   x = x + 1
   If x > 7 Then x = 1
    For k = 1 to 3
     For j = N to 2 Step -1
      A(j) = A(j - 1)
     Next j
    Next k
    Send
    waitms 60
   A(1) = p
  Next i
End Sub

'  
Sub R_Kap_R()
 x = 1
  For i = 1 to M
   p = A(N)
   Select case x
    Case 1 : A(1) = 255
             A(2) = 0
             A(3) = 0
    Case 2 : A(1) = 90
             A(2) = 0
             A(3) = 0
    Case 3 : A(1) = 50
              A(2) = 0
              A(3) = 0
    Case 4 : A(1) = 10
             A(2) = 0
             A(3) = 0
    Case 5 : A(1) = 1
             A(2) = 0
             A(3) = 0
    Case 6 : A(1) = 0
             A(2) = 0
             A(3) = 0
    Case 7 : A(1) = 0
             A(2) = 0
             A(3) = 0
   End Select
   x = x + 1
   If x > 7 Then x = 1
    For k = 1 to 3
     For j = N to 2 Step -1
      A(j) = A(j - 1)
     Next j
    Next k
    Send
    waitms 60
   A(1) = p
  Next i
End Sub

'  
Sub B_Kap_L()
 x = 1
  For i = 1 to M
   p = A(1)
   Select case x
    Case 1 : A(469) = 0
             A(470) = 0
             A(471) = 255
    Case 2 : A(469) = 0
             A(470) = 0
             A(471) = 100
    Case 3 : A(469) = 0
             A(470) = 0
             A(471) = 50
    Case 4 : A(469) = 0
             A(470) = 0
             A(471) = 10
    Case 5 : A(469) = 0
             A(470) = 0
             A(471) = 1
    Case 6 : A(469) = 0
             A(470) = 0
             A(471) = 0
    Case 7 : A(469) = 0
             A(470) = 0
             A(471) = 0
   End Select
   x = x + 1
   If x > 7 Then x = 1
    For k = 1 to 3
     For j = 1 to 470
      A(j) = A(j + 1)
     Next j
    Next k
    Send
    waitms 60
   A(N) = p
  Next i
End Sub

'  
Sub G_Kap_L()
 x = 1
  For i = 1 to M
   p = A(1)
   Select case x
    Case 1 : A(469) = 0
             A(470) = 255
             A(471) = 0
    Case 2 : A(469) = 0
             A(470) = 100
             A(471) = 0
    Case 3 : A(469) = 0
             A(470) = 50
             A(471) = 0
    Case 4 : A(469) = 0
             A(470) = 10
             A(471) = 0
    Case 5 : A(469) = 0
             A(470) = 1
             A(471) = 0
    Case 6 : A(469) = 0
             A(470) = 0
             A(471) = 0
    Case 7 : A(469) = 0
             A(470) = 0
             A(471) = 0
   End Select
   x = x + 1
   If x > 7 Then x = 1
    For k = 1 to 3
     For j = 1 to 470
      A(j) = A(j + 1)
     Next j
    Next k
    Send
    waitms 60
   A(N) = p
  Next i
End Sub

'  
Sub R_Kap_L()
 x = 1
  For i = 1 to M
   p = A(1)
   Select case x
    Case 1 : A(469) = 255
             A(470) = 0
             A(471) = 0
    Case 2 : A(469) = 100
             A(470) = 0
             A(471) = 0
    Case 3 : A(469) = 50
             A(470) = 0
             A(471) = 0
    Case 4 : A(469) = 10
             A(470) = 0
             A(471) = 0
    Case 5 : A(469) = 1
             A(470) = 0
             A(471) = 0
    Case 6 : A(469) = 0
             A(470) = 0
             A(471) = 0
    Case 7 : A(469) = 0
             A(470) = 0
             A(471) = 0
   End Select
   x = x + 1
   If x > 7 Then x = 1
    For k = 1 to 3
     For j = 1 to 470
      A(j) = A(j + 1)
     Next j
    Next k
    Send
    waitms 60
   A(N) = p
  Next i
End Sub

'     
Sub RND_Kap_R()
 x = 1
  For i = 1 to 500
   p = A(N)
   RND_Col
   Select case x
    Case 1 : A(1) = R
             A(2) = G
             A(3) = B
    Case 2 : A(1) = R
             A(2) = G
             A(3) = B
    Case 3 : A(1) = R
              A(2) = G
              A(3) = B
    Case 4 : A(1) = R
             A(2) = G
             A(3) = B
    Case 5 : A(1) = R
             A(2) = G
             A(3) = B
    Case 6 : A(1) = 0
             A(2) = 0
             A(3) = 0
    Case 7 : A(1) = 0
             A(2) = 0
             A(3) = 0
   End Select
   x = x + 1
   If x > 7 Then x = 1
    For k = 1 to 3
     For j = N to 2 Step -1
      A(j) = A(j - 1)
     Next j
    Next k
    Send
    waitms 60
   A(1) = p
  Next i
End Sub

'     
Sub RND_Kap_L()
 x = 1
  For i = 1 to 500
   p = A(1)
   RND_Col
   Select case x
    Case 1 : A(469) = R
             A(470) = G
             A(471) = B
    Case 2 : A(469) = R
             A(470) = G
             A(471) = B
    Case 3 : A(469) = R
             A(470) = G
             A(471) = B
    Case 4 : A(469) = R
             A(470) = G
             A(471) = B
    Case 5 : A(469) = R
             A(470) = G
             A(471) = B
    Case 6 : A(469) = 0
             A(470) = 0
             A(471) = 0
    Case 7 : A(469) = 0
             A(470) = 0
             A(471) = 0
   End Select
   x = x + 1
   If x > 7 Then x = 1
    For k = 1 to 3
     For j = 1 to 470
      A(j) = A(j + 1)
     Next j
    Next k
    Send
    waitms 60
   A(N) = p
  Next i
End Sub

'   
Sub B_Two_Kap
ClearArray
 x = 1
  For i = 1 to 500
   Select case x
    Case 1 : A(472) = 0
             A(473) = 0
             A(474) = 255
             A(1) = 0
             A(2) = 0
             A(3) = 255
    Case 2 : A(472) = 0
             A(473) = 0
             A(474) = 150
             A(1) = 0
             A(2) = 0
             A(3) = 150
    Case 3 : A(472) = 0
             A(473) = 0
             A(474) = 90
             A(1) = 0
             A(2) = 0
             A(3) = 90
    Case 4 : A(472) = 0
             A(473) = 0
             A(474) = 40
             A(1) = 0
             A(2) = 0
             A(3) = 40
    Case 5 : A(472) = 0
             A(473) = 0
             A(474) = 1
             A(1) = 0
             A(2) = 0
             A(3) = 1
    Case 6 : A(472) = 0
             A(473) = 0
             A(474) = 0
             A(1) = 0
             A(2) = 0
             A(3) = 0
    Case 7 : A(472) = 0
             A(473) = 0
             A(474) = 0
             A(1) = 0
             A(2) = 0
             A(3) = 0
   End Select
   x = x + 1
   If x > 7 Then x = 1

   p1 = A(237)
   p2 = A(238)
   s = 237

   For k = 1 to 3
     For j = 238 to 474
      A(j) = A(j + 1)
      A(s) = A(s - 1)
      s = s - 1
      If s < 1 Then s = 237
     Next j
   Next k
   Send
   A(474) = p2
   A(1) = p1
   waitms 60
  Next i
End Sub

'   
Sub G_Two_Kap
ClearArray
 x = 1
  For i = 1 to 500
   Select case x
    Case 1 : A(472) = 0
             A(473) = 255
             A(474) = 0
             A(1) = 0
             A(2) = 255
             A(3) = 0
    Case 2 : A(472) = 0
             A(473) = 150
             A(474) = 0
             A(1) = 0
             A(2) = 150
             A(3) = 0
    Case 3 : A(472) = 0
             A(473) = 90
             A(474) = 0
             A(1) = 0
             A(2) = 90
             A(3) = 0
    Case 4 : A(472) = 0
             A(473) = 40
             A(474) = 0
             A(1) = 0
             A(2) = 40
             A(3) = 0
    Case 5 : A(472) = 0
             A(473) = 1
             A(474) = 0
             A(1) = 0
             A(2) = 1
             A(3) = 0
    Case 6 : A(472) = 0
             A(473) = 0
             A(474) = 0
             A(1) = 0
             A(2) = 0
             A(3) = 0
    Case 7 : A(472) = 0
             A(473) = 0
             A(474) = 0
             A(1) = 0
             A(2) = 0
             A(3) = 0
   End Select
   x = x + 1
   If x > 7 Then x = 1

   p1 = A(237)
   p2 = A(238)
   s = 237

   For k = 1 to 3
     For j = 238 to 474
      A(j) = A(j + 1)
      A(s) = A(s - 1)
      s = s - 1
      If s < 1 Then s = 237
     Next j
   Next k
   Send
   A(474) = p2
   A(1) = p1
   waitms 60
  Next i
End Sub

'   
Sub R_Two_Kap
ClearArray
 x = 1
  For i = 1 to 500
   Select case x
    Case 1 : A(472) = 255
             A(473) = 0
             A(474) = 0
             A(1) = 255
             A(2) = 0
             A(3) = 0
    Case 2 : A(472) = 150
             A(473) = 0
             A(474) = 0
             A(1) = 150
             A(2) = 0
             A(3) = 0
    Case 3 : A(472) = 90
             A(473) = 0
             A(474) = 0
             A(1) = 90
             A(2) = 0
             A(3) = 0
    Case 4 : A(472) = 40
             A(473) = 0
             A(474) = 0
             A(1) = 40
             A(2) = 0
             A(3) = 0
    Case 5 : A(472) = 1
             A(473) = 0
             A(474) = 0
             A(1) = 1
             A(2) = 0
             A(3) = 0
    Case 6 : A(472) = 0
             A(473) = 0
             A(474) = 0
             A(1) = 0
             A(2) = 0
             A(3) = 0
    Case 7 : A(472) = 0
             A(473) = 0
             A(474) = 0
             A(1) = 0
             A(2) = 0
             A(3) = 0
   End Select
   x = x + 1
   If x > 7 Then x = 1

   p1 = A(237)
   p2 = A(238)
   s = 237

   For k = 1 to 3
     For j = 238 to 474
      A(j) = A(j + 1)
      A(s) = A(s - 1)
      s = s - 1
      If s < 1 Then s = 237
     Next j
   Next k
   Send
   A(474) = p2
   A(1) = p1
   waitms 60
  Next i
End Sub

'   
Sub RGB_Two_Kap()
ClearArray
 x = 1
  For i = 1 to 500
   Select case x
    Case 1 : A(472) = 255
             A(473) = 0
             A(474) = 0
             A(1) = 255
             A(2) = 0
             A(3) = 0
    Case 2 : A(472) = 150
             A(473) = 0
             A(474) = 150
             A(1) = 150
             A(2) = 0
             A(3) = 150
    Case 3 : A(472) = 0
             A(473) = 90
             A(474) = 0
             A(1) = 0
             A(2) = 90
             A(3) = 0
    Case 4 : A(472) = 40
             A(473) = 40
             A(474) = 0
             A(1) = 40
             A(2) = 40
             A(3) = 0
    Case 5 : A(472) = 0
             A(473) = 0
             A(474) = 1
             A(1) = 1
             A(2) = 0
             A(3) = 1
    Case 6 : A(472) = 0
             A(473) = 0
             A(474) = 0
             A(1) = 0
             A(2) = 0
             A(3) = 0
    Case 7 : A(472) = 0
             A(473) = 0
             A(474) = 0
             A(1) = 0
             A(2) = 0
             A(3) = 0
   End Select
   x = x + 1
   If x > 7 Then x = 1

   p1 = A(237)
   p2 = A(238)
   s = 237

   For k = 1 to 3
     For j = 238 to 474
      A(j) = A(j + 1)
      A(s) = A(s - 1)
      s = s - 1
      If s < 1 Then s = 237
     Next j
   Next k
   Send
   A(474) = p2
   A(1) = p1
   waitms 60
  Next i
End Sub

' 
Sub YellowExplosion()
 For i = 1 to 468 step 3
  A(i) = 150
  A(i + 1) = 150
  A(i + 2) = 0
 Next i
  Send
End Sub

'  
Sub Off_YellowExplosion()
 R = 150
 G = 150
 For R = 150 to 0 step -1
  For i = 1 to 468 step 3
   A(i) = R
   A(i + 1) = G
   A(i + 2) = 0
  Next i
   Send
   waitms 30
  G = G - 1
 Next R
End Sub

' 
Sub LilExplosion()
 For i = 1 to 468 step 3
  A(i) = 200
  A(i + 1) = 0
  A(i + 2) = 200
 Next i
  Send
End Sub

'  
Sub Off_LilExplosion()
 R = 200
 B = 200
 For R = 200 to 0 step -1
  For i = 1 to 468 step 3
   A(i) = R
   A(i + 1) = 0
   A(i + 2) = B
  Next i
   Send
   waitms 30
  B = B - 1
 Next R
End Sub

'  
Sub RND_Color()

For s = 1 To 10
'  
GenCol:
Tred = RND(256)
Tgreen = RND(256)
Tblue = RND(256)

'    100,     0
 If Tred < 100 Then Tred = 0
 If Tgreen < 100 Then Tgreen = 0
 If Tblue < 100 Then Tblue = 0

'   ,      
 If Tred = 0 and Tgreen = 0 and Tblue = 0 Then
   Cikl0:
   temp4 = RND(16)
   If temp4 <= 0 or temp4 > 3 Then GoTo Cikl0
    If temp4 = 1 Then
      Tred = 255
      Tgreen = 0
      Tblue = 0
    End If
    If temp4 = 2 Then
      Tred = 0
      Tgreen = 255
      Tblue = 0
    End If
    If temp4 = 3 Then
      Tred = 0
      Tgreen = 0
      Tblue = 255
    End If
 End If
 temp1 = Tred - Tgreen : temp1 = abs(temp1)
 temp2 = Tred - Tblue : temp2 = abs(temp2)
 temp3 = Tgreen - Tblue : temp3 = abs(temp3)
'    ,   ,  
 If temp1 < 150 and temp2 < 150 and temp3 < 150 Then GoTo GenCol
'  ,    0,4 (32767)   
'     1-RED 2-GREEN 3-BLUE
 ColourOff = RND(65536)
   If ColourOff < 13100 Then
   CIKL1:
     temp4 = RND(16)
     If temp4 = 0 or temp4 > 3 Then GoTo CIKL1
'   0 - 20%
     If temp4 = 1 Then
   CIKL2:
       temp4 = RND(32768)
       If temp4 = 0 or temp4 > 3276 Then GoTo CIKL2
       tmp = temp4 / 32767
       tmp = tmp * Tred
       Tred = Int(tmp)
     End If
     If temp4 = 2 Then
   CIKL3:
       temp4 = RND(32768)
       If temp4 = 0 or temp4 > 3276 Then GoTo CIKL3
       tmp = temp4 / 32767
       tmp = tmp * Tgreen
       Tgreen = Int(tmp)
     End If
     If temp4 = 3 Then
   CIKL4:
       temp4 = RND(32768)
       If temp4 = 0 or temp4 > 3276 Then GoTo CIKL4
       tmp = temp4 / 32767
       tmp = tmp * Tblue
       Tblue = Int(tmp)
     End If
   End If

'  ,      255 
  d_Red = Tred -Red : d_Red = d_Red / 255
  d_Green = TGreen -Green : d_Green = d_Green / 255
  d_Blue = Tblue -Blue : d_Blue = d_Blue / 255

'    5  10 
CIKL5:
  temp4 = RND(10)
  If temp4 < 1 or temp4 > 5 Then GoTo CIKL5

'   
   tmp = temp4 / 255
   tmp = tmp * 100
   Times = int(tmp)

CIKL6:
  Tr = Int(Red)
  If Tred <> Tr Then
    Red = Red + d_Red
    R = Int(Red)
  End If

  Tg = Int(Green)
  If Tgreen <> Tg Then
    Green = Green + d_Green
    G = Int(Green)
  End If

  Tb = Int(Blue)
  If Tblue <> Tb Then
    Blue = Blue + d_Blue
    B = Int(Blue)
  End If

 For i = 1 to 468 step 3
  A(i) = R
  A(i + 1) = G
  A(i + 2) = B
 Next i
 Send

  Waitms Times
   If Tred <> Tr or Tgreen <> Tg or Tblue <> Tb Then GoTo CIKL6

  Times = Times * 255
  Waitms Times
Next s
End Sub

'   
Sub Nab_LR()
 For j = 1 to 468 Step 3
  RND_Col
  A(j) = R
  A(j + 1) = G
  A(j + 2) = B
  Send
  ClearArray
 Waitms 5
 Next i
End Sub

'   
Sub Nab_RL()
 For j = 468 to 0 Step -3
  RND_Col
  A(j -2) = R
  A(j - 1) = G
  A(j) = B
  Send
  ClearArray
 Waitms 5
 Next i
End Sub

'        
Sub OnRND_LR()
 For i = 1 to 468 step 3
 RND_Col
  A(i) = R
  A(i + 1) = G
  A(i + 2) = B
  Send
  waitms 10
 Next i
End Sub

'        
Sub OnRND_RL()
 For i = 468 to 0 step -3
 RND_Col
  A(i -2) = R
  A(i - 1) = G
  A(i) = B
  Send
  waitms 10
 Next i
End Sub

'----------------------------------  --------------------------------
 Dim i As Word , j As Word , k As Word , x As Byte , p As Byte
 Dim s As Integer , p1 As Integer , p2 As Integer
 Dim R As Byte , G As Byte , B As Byte
 Dim S1 As Byte , S2 As Byte , S3 As Byte
 Dim t1 As Integer , t2 As Integer , t3 As Integer
 Dim A(474) As Byte

 Dim Red As Single , Green As Single , Blue As Single       ' 
 Dim Tred As Word , Tgreen As Word , Tblue As Word          ' 
 Dim d_Red As Single , d_Green As single , d_Blue As Single '   
 Dim Times As Word                                          ' 
 Dim Tr as Byte , Tg as Byte , Tb as Byte                   '
 Dim tmp As Single
 Dim ColourOff As Word                                      '   
 Dim temp1 As Integer , temp2 As Integer , temp3 As Integer , temp4 As Word

 Const M = 156
 Const N = 474
 Dim ___rseed as word
 '---------------------------------  -------------------------------
' SD
 Config PinA.0 = Output
 SD Alias PortA.0

' CK
 Config PinA.1 = Output
 CK Alias PortA.1

' 
 Config PinB.7 = Output
 Ind Alias PortB.7

Config SPI = SOFT , DIN = PINA.2 , DOUT = PORTA.0 , SS = NONE , CLOCK = PORTA.1

'--------------------------------  -----------------------------------

 SPIINIT                                                    'Init SPI state and pins.
 Set Ind
ClearArray
 ___rseed = 10234

Do
'   
RinG
'   
GinB
'   
BinR
'      
OnG_LR
'      
OnB_RL
'      
OnR_LR
'      
OnG_RL
'   
B_Middle
'   
G_Middle
'   
R_Middle
' 
OffLed_LR
'   
RGB_Two_Kap
'  
B_Kap_R
'  
R_Kap_L
'  
B_Kap_L
'  
G_Kap_R
'  
G_Kap_L
'  
R_Kap_R
'     
RND_Kap_R
'     
RND_Kap_L
'   
B_Two_Kap
' 
YellowExplosion
'  
Off_YellowExplosion
'   
G_Two_Kap
'   
R_Two_Kap
' 
LilExplosion
'  
Off_LilExplosion
'   
RGB_Two_Kap
'  
RND_Color
' 
OffLed_RL
'        
OnGradient_LR
'        
OnGradient_RL
'      
OnR_LR
' 
OffLed_RL
'     
RND_Kap_R
'     
RND_Kap_L
'   
B_Middle
'   
G_Middle
'   
R_Middle
' 
OffLed_LR
'   
For k = 1 To 3
 Nab_LR
'   
 Nab_RL
Next k
'        
For k = 1 to 5
OnRND_LR
' 
OffLed_RL
'        
OnRND_RL
' 
OffLed_LR
Next k
Loop

end                                                         'end program